/*	wt]xH쎺	J.Sugita	2011/05/27

eeprom.hŒ`Ăeeprom_read/write_byte/word()ɂeeprom_busy_wait()܂܂ĂB
āA(eeprlib_cdc.c)ł̋Lq͏ȗB
*/

#include	<avr/io.h>
#include	<avr/eeprom.h>
#include	"eeprlib_cdc.h"

//EEPROMR}hiPCœ`Ɓj
enum	E_EEPRLIB_CMMAND
{
	ERCMD_READ_BYTE,
	ERCMD_READ_WORD,
	ERCMD_WRITE_ADDR,
	ERCMD_WRITE_BYTE,
	ERCMD_WRITE_WORD
};

static	uint16_t	addr = 0;
static	uint8_t	resultBuf[3] = {0};		//Result: [0]LoByte, [1]HiByte, [2]status

//resultBuf[]̃CfbNX
#define	R_LO	0
#define	R_HI	1
#define	R_ST	2

//resultBuf[R_ST]Ɋi[l
#define	DATA_16BIT	0x11
#define	DATA_8BIT	0x01
#define	DATA_NONE	0x00

uint8_t	eepromResult(uint8_t ers)
{
	switch (ers)
	{
	case ERS_EXIST_HI:	return (resultBuf[R_ST] & 0x10) ? 1 : 0;
	case ERS_GET_HI:	return resultBuf[R_HI];
	case ERS_EXIST_LO:	return (resultBuf[R_ST] & 0x01) ? 1 : 0;
	case ERS_GET_LO:	return resultBuf[R_LO];
	default:	break;
	}
	return 0;
}

static	void	eepromReadByte(uint8_t addrH, uint8_t addrL)
{
	uint8_t data;
	addr = ((uint16_t)addrH << 8 | (uint16_t)addrL);
	data = eeprom_read_byte((uint8_t*)addr);
	resultBuf[R_ST] = DATA_8BIT;
	resultBuf[R_HI] = 0;
	resultBuf[R_LO] = data;
}

static	void	eepromReadWord(uint8_t addrH, uint8_t addrL)
{
	uint16_t data;
	addr = ((uint16_t)addrH << 8 | (uint16_t)addrL);
	data = eeprom_read_word((uint16_t*)addr);
	resultBuf[R_ST] = DATA_16BIT;
	resultBuf[R_HI] = (data >> 8) & 0xFF;
	resultBuf[R_LO] = data & 0xFF;
}

static	void	eepromWriteAddr(uint8_t addrH, uint8_t addrL)
{
	addr = ((uint16_t)addrH << 8 | (uint16_t)addrL);
	resultBuf[R_ST] = DATA_NONE;
	resultBuf[R_HI] = 0;
	resultBuf[R_LO] = 0;
}

static	void	eepromWriteByte(uint8_t data)
{
	//OeepromWriteAddr()sĂ邱
	eeprom_write_byte((uint8_t*)addr, data);
}

static	void	eepromWriteWord(uint8_t dataH, uint8_t dataL)
{
	//OeepromWriteAddr()sĂ邱
	uint16_t data = ((uint16_t)dataH << 8 | (uint16_t)dataL);
	eeprom_write_word((uint16_t*)addr, data);
}

void	eepromAction(uint8_t cmd, uint8_t val, uint8_t val2)
{
	switch (cmd)
	{
	case ERCMD_READ_BYTE:	eepromReadByte(val, val2);	break;
	case ERCMD_READ_WORD:	eepromReadWord(val, val2);	break;
	case ERCMD_WRITE_ADDR:	eepromWriteAddr(val, val2);	break;
	case ERCMD_WRITE_BYTE:	eepromWriteByte(val);	break;
	case ERCMD_WRITE_WORD:	eepromWriteWord(val, val2);	break;
	default:	break;
	}
}
